import { Vector } from "prelude.ts";
import { AttributeDirectiveHandler, TagDirectiveHandler } from "./ng-directives";
import { NgFilter } from "./filters";
/**
 * @hidden
 */
export interface NgScope {
    readonly xpathDepth: number;
    readonly closeSource: () => string;
    readonly variables: string[];
}
/**
 * @hidden
 */
export declare function requireDefined<T>(x: T | undefined): T;
export declare function collectionKeepDefined<T>(l: Vector<T | undefined>): Vector<T>;
export declare function listKeepDefined<T>(l: Vector<T | undefined>): Vector<T>;
/**
 * http://stackoverflow.com/a/16184477/516188
 * @hidden
 */
export declare function normalizeTagAttrName(name: string): string;
/**
 * @hidden
 */
export declare function parseView(resolveImportsAsNonScope: boolean, fileName: string, viewFragments: string[], importNames: string[], tagDirectiveHandlers: Vector<TagDirectiveHandler>, attrDirectiveHandlers: Vector<AttributeDirectiveHandler>, ngFilters: Vector<NgFilter>): Promise<string>;
