"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var assert = require("assert");
var child_process_1 = require("child_process");
var fs_1 = require("fs");
var ng_typeview_1 = require("../src/ng-typeview");
var filters_1 = require("../src/filters");
var controller_parser_1 = require("../src/controller-parser");
var ng_directives_1 = require("../src/ng-directives");
var ts = require("typescript");
var filters = filters_1.defaultNgFilters.concat([
    new filters_1.NgFilter("formatNumber", "(input: string, formatType: 'hex'|'dec') => string")
]);
var checkViewFragmentExtractor = {
    interceptAstNode: ts.SyntaxKind.CallExpression,
    getViewFragments: function (_node) {
        var node = _node;
        if (node.expression.getText().endsWith(".checkViewFragment")) {
            if (node.arguments.length === 1 &&
                [ts.SyntaxKind.NoSubstitutionTemplateLiteral, ts.SyntaxKind.StringLiteral]
                    .indexOf(node.arguments[0].kind) >= 0) {
                return [node.arguments[0].text];
            }
            else {
                console.warn("Warning: ignoring non-conformant checkViewFragment call." + node.getText());
            }
        }
        return [];
    }
};
describe("processProject", function () {
    it("should generate view test files", function () { return __awaiter(_this, void 0, void 0, function () {
        var actualContents, expectedContents, actualContentsDirective, expectedContentsDirective, actualContentsDirective2, expectedContentsDirective2, actualContentsDirective3, expectedContentsDirective3, actualContentsDirective4, expectedContentsDirective4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    child_process_1.execSync("git clean -xf test/data");
                    return [4 /*yield*/, ng_typeview_1.processProject({
                            path: "test/data",
                            blacklistedPaths: [],
                            ngFilters: filters,
                            ctrlViewConnectors: controller_parser_1.defaultCtrlViewConnectors,
                            modelViewConnectors: controller_parser_1.defaultModelViewConnectors,
                            extraCtrlViewConnections: [],
                            tagDirectives: ng_directives_1.defaultTagDirectiveHandlers,
                            attributeDirectives: ng_directives_1.defaultAttrDirectiveHandlers,
                            ctrlViewFragmentExtractors: [checkViewFragmentExtractor]
                        })];
                case 1:
                    _a.sent();
                    actualContents = fs_1.readFileSync("test/data/test-ctrl_test-view_viewtest.ts").toString();
                    expectedContents = fs_1.readFileSync("test/data/expected_testview.ts").toString();
                    assert.equal(expectedContents, actualContents);
                    actualContentsDirective = fs_1.readFileSync("test/data/test-directive_directive-template_viewtest.ts").toString();
                    expectedContentsDirective = fs_1.readFileSync("test/data/expected_directive_testview.ts").toString();
                    assert.equal(expectedContentsDirective, actualContentsDirective);
                    actualContentsDirective2 = fs_1.readFileSync("test/data/test-directive2_directive-template_viewtest.ts").toString();
                    expectedContentsDirective2 = fs_1.readFileSync("test/data/expected_directive2_testview.ts").toString();
                    assert.equal(expectedContentsDirective2, actualContentsDirective2);
                    actualContentsDirective3 = fs_1.readFileSync("test/data/test-directive3_directive-template_viewtest.ts").toString();
                    expectedContentsDirective3 = fs_1.readFileSync("test/data/expected_directive3_testview.ts").toString();
                    assert.equal(expectedContentsDirective3, actualContentsDirective3);
                    actualContentsDirective4 = fs_1.readFileSync("test/data/test-directive4_directive-template_viewtest.ts").toString();
                    expectedContentsDirective4 = fs_1.readFileSync("test/data/expected_directive4_testview.ts").toString();
                    assert.equal(expectedContentsDirective4, actualContentsDirective4);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=ng-typeview.js.map