"use strict";
exports.__esModule = true;
var assert = require("assert");
var prelude_ts_1 = require("prelude.ts");
var view_ngexpression_parser_1 = require("../src/view-ngexpression-parser");
describe("addScopeAccessors", function () {
    it("should add $scope properly", function () {
        var fakeScopeInfo = prelude_ts_1.Vector.of({
            xpathDepth: 1,
            closeSource: function () { return ""; },
            variables: []
        }, {
            xpathDepth: 2,
            closeSource: function () { return ""; },
            variables: []
        });
        var assertScopeAcc = function (expected, input) { return assert.equal(expected, view_ngexpression_parser_1.addScopeAccessors(fakeScopeInfo, input)); };
        assertScopeAcc("$scope.data.value", "data.value");
        assertScopeAcc("$scope.data.value !== undefined", "data.value !== undefined");
        assertScopeAcc("!$scope.wasProvidedWorkbook()", "!wasProvidedWorkbook()");
        assertScopeAcc("$scope.info.subscribedEmails.length > 0", "info.subscribedEmails.length > 0");
        assertScopeAcc("$scope.movieInfo.legendEnabled && $scope.movieInfo.legend.length > 0", "movieInfo.legendEnabled && movieInfo.legend.length > 0");
        assertScopeAcc("$scope.selectedScreen.images[$scope.idx - 1] !== null", "selectedScreen.images[idx - 1] !== null");
        assertScopeAcc("$scope.selectedScreen.images[$scope.idx - 1].name", "selectedScreen.images[idx - 1].name");
        assertScopeAcc("$scope.getSelectedImage($scope.selectedScreen.images[$scope.idx - 1])", "getSelectedImage(selectedScreen.images[idx - 1])");
        assertScopeAcc("$scope.fType === 'test' || $scope.fType === 'test1'", "fType === 'test' || fType === 'test1'");
        assertScopeAcc("$scope.wasProvidedWorkbook ? '' : 'ng-invalid'", "wasProvidedWorkbook ? '' : 'ng-invalid'");
        assertScopeAcc('{"internal-tab": true, "internal-active": $scope.idx === 0}', '{"internal-tab": true, "internal-active": idx === 0}');
        assertScopeAcc("{name: $scope.wasProvidedWorkbook}", "{name: wasProvidedWorkbook}");
        assertScopeAcc("new RegExp(\"^[a-z]+$\")", "/^[a-z]+$/");
        // yes, that next one is pretty horrific. actually spotted that in the wild.
        assertScopeAcc("{true: 'glyphicon-chevron-up', false: 'glyphicon-chevron-down'}[$scope.showList]", "{true:'glyphicon-chevron-up', false:'glyphicon-chevron-down'}[showList]");
        assertScopeAcc("!{entity: $scope.imported[0], selected: true}.entity.selectable", "!{entity: imported[0], selected: true}.entity.selectable");
        assertScopeAcc("{entity: $scope.imported[0], selected: true}.selected", "{entity: imported[0], selected: true}.selected");
        assertScopeAcc("{entity: $scope.imported[0], selected: true}.entity[$scope.col.field]", "{entity: imported[0], selected: true}.entity[col.field]");
    });
});
//# sourceMappingURL=view-ngexpression-parser.js.map